const string        = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
var prefService     = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

var otb_optBool     = new Array();
var otb_optInt      = new Array();
var otb_optStr      = new Array();
var otb_description = null;
var otb_signature   = null;
var otb_document    = null;

function otb_init() {
	try{
		switch (window.arguments[1]){
			case "signatures":
				document.getElementById('otb_page-list').selectedIndex = 2;
				break;
			case "communities":
				document.getElementById('otb_page-list').selectedIndex = 1;
				break;
			default: 
			document.getElementById('otb_page-list').selectedIndex = 0;
		}
		otb_document = window.arguments[0];
	}catch(e){
		document.getElementById('otb_page-list').selectedIndex = 0;
		otb_document = self.parent.opener.parent.opener.document;
	}
}

function otb_changePage(pageList) {
    otb_storeOptions();
    document.getElementById("otb-options-iframe").setAttribute("src", pageList.selectedItem.getAttribute("value"));
}


function otb_initializeOptions() { // Initializes the options dialog box
    const prefService  = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
    const selectedPage = document.getElementById("otb_page-list").selectedItem.getAttribute("value");
	
    if(selectedPage.indexOf("general") != -1) { otb_initializeGeneral(); }
    else if(selectedPage.indexOf("signatures") != -1) { otb_initializeSignature(); }
    else if(selectedPage.indexOf("communities") != -1) { otb_initializeCommunities(); } //dk
}

function otb_initializeGeneral() { // Initializes the general page
    prefService  = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");	
	const pageDoc       = document.getElementById("otb-options-iframe").contentDocument;
    const stringBundle  = document.getElementById("otbstrings");
	
	open_in = (typeof otb_optInt["otb.opt.open_in"] != "undefined") ? (otb_optInt["otb.opt.open_in"]) : (prefService.getIntPref("otb.opt.open_in"));
	open_src_in = (typeof otb_optInt["otb.opt.open_src_in"] != "undefined") ? (otb_optInt["otb.opt.open_src_in"]) : (prefService.getIntPref("otb.opt.open_src_in"));
	iconsize = (typeof otb_optInt["otb.opt.iconsize"] != "undefined") ? (otb_optInt["otb.opt.iconsize"]) : (prefService.getIntPref("otb.opt.iconsize"));
	show_BBMenu = (typeof otb_optBool["otb.opt.showBMMenu"] != "undefined") ? (otb_optBool["otb.opt.showBMMenu"]) : (prefService.getBoolPref("otb.opt.showBMMenu"));
	show_CommSubmenu = (typeof otb_optBool["otb.opt.commSubMenu"] != "undefined") ? (otb_optBool["otb.opt.commSubMenu"]) : (prefService.getBoolPref("otb.opt.commSubMenu"));
	show_profSubmenu = (typeof otb_optBool["otb.opt.profSubMenu"] != "undefined") ? (otb_optBool["otb.opt.profSubMenu"]) : (prefService.getBoolPref("otb.opt.profSubMenu"));
	show_ContextMenu = (typeof otb_optBool["otb.opt.ContextMenu"] != "undefined") ? (otb_optBool["otb.opt.ContextMenu"]) : (prefService.getBoolPref("otb.opt.ContextMenu"));
	show_ContextLinks = (typeof otb_optBool["otb.opt.ContextLinks"] != "undefined") ? (otb_optBool["otb.opt.ContextLinks"]) : (prefService.getBoolPref("otb.opt.ContextLinks"));
	AutoHide = (typeof otb_optBool["otb.opt.AutoHide"] != "undefined") ? (otb_optBool["otb.opt.AutoHide"]) : (prefService.getBoolPref("otb.opt.AutoHide"));
	HideSearch = (typeof otb_optBool["otb.opt.HideSearch"] != "undefined") ? (otb_optBool["otb.opt.HideSearch"]) : (prefService.getBoolPref("otb.opt.HideSearch"));

	pageDoc.getElementById('otb_opt_openin').selectedIndex=open_in;
	pageDoc.getElementById('otb_opt_open_src_in').selectedIndex=open_src_in;
	pageDoc.getElementById('otb_opt_iconsize').selectedIndex=iconsize;
	pageDoc.getElementById('otb_opt_showBMMenu').checked=show_BBMenu;
	pageDoc.getElementById('otb_opt_commSubMenu').checked= show_CommSubmenu;
	pageDoc.getElementById('otb_opt_profSubMenu').checked=show_profSubmenu;
	pageDoc.getElementById('otb_opt_ContextMenu').checked=show_ContextMenu;
	pageDoc.getElementById('otb_opt_ContextLinks').checked=show_ContextLinks;
	pageDoc.getElementById('otb_opt_OnlyInOrkut').checked=AutoHide;
	pageDoc.getElementById('otb_opt_HideSearch').checked=HideSearch;

	document.getElementById("otb-options-header").setAttribute("title",stringBundle.getString("otb.opt.general.header"));
}

function otb_initializeSignature() { // Initializes the signatures
    const pageDoc       = document.getElementById("otb-options-iframe").contentDocument;
//    prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
    const otb_sigListbox       = pageDoc.getElementById("otb_sigListbox");
    const stringBundle  = document.getElementById("otbstrings");

    var description      = null;    var descriptionValue = null;
    var signature        = null;    var signatureValue   = null;
    var listItem         = null;	var signatureCount   = 0;

    if(typeof otb_optInt["otb.singatures.count"] != "undefined") {     // If the user signatures count preference is set
        signatureCount = otb_optInt["otb.singatures.count"];
    }
    else if(prefService.prefHasUserValue("otb.singatures.count")) {
        signatureCount = prefService.getIntPref("otb.singatures.count");
    }

    for(var i = 1; i <= signatureCount; i++) { // Loop through the possible signatures
	    description = "otb.opt.sig." + i + ".description";
	    signature   = "otb.opt.sig." + i + ".signature";

        if(typeof otb_optStr[description] != "undefined") { // If the description is set
            descriptionValue = otb_optStr[description].trim();
        }
        else if(prefService.prefHasUserValue(description)) {
	        descriptionValue = prefService.getComplexValue(description, Components.interfaces.nsISupportsString).data.trim();
        }
        else  { descriptionValue = null; }

        if(typeof otb_optStr[signature] != "undefined") {   // If the user signature
            signatureValue = otb_optStr[signature].trim();
        }
        else if(prefService.prefHasUserValue(signature)) {
	        signatureValue = prefService.getComplexValue(signature, Components.interfaces.nsISupportsString).data.trim();
        }
        else  { signatureValue = null; }

        if(descriptionValue) { listItem = otb_sigListbox.appendItem(descriptionValue, signatureValue);  } // If the description is set
    }
	otbSelectItem();
	document.getElementById("otb-options-header").setAttribute("title",stringBundle.getString("otb.opt.signatures.header"));
}

function otb_storeOptions() { // Stores the user's options to be saved later
    const iFrame       = document.getElementById("otb-options-iframe");
    const iFrameSrc    = iFrame.getAttribute("src");
    const pageDoc = iFrame.contentDocument;

    if(iFrameSrc.indexOf("general") != -1) {   // If this is the general page
		otb_optInt["otb.opt.open_in"] = pageDoc.getElementById("otb_opt_openin").value;
		otb_optInt["otb.opt.open_src_in"] = pageDoc.getElementById("otb_opt_open_src_in").value;		
		otb_optInt["otb.opt.iconsize"] = pageDoc.getElementById("otb_opt_iconsize").value;
		otb_optBool["otb.opt.showBMMenu"] = pageDoc.getElementById("otb_opt_showBMMenu").checked;
		otb_optBool["otb.opt.commSubMenu"] = pageDoc.getElementById("otb_opt_commSubMenu").checked;
		otb_optBool["otb.opt.profSubMenu"] = pageDoc.getElementById("otb_opt_profSubMenu").checked;
		otb_optBool["otb.opt.ContextMenu"] = pageDoc.getElementById("otb_opt_ContextMenu").checked;
		otb_optBool["otb.opt.ContextLinks"] = pageDoc.getElementById("otb_opt_ContextLinks").checked;
		otb_optBool["otb.opt.AutoHide"] = pageDoc.getElementById("otb_opt_OnlyInOrkut").checked;
		otb_optBool["otb.opt.HideSearch"] = pageDoc.getElementById("otb_opt_HideSearch").checked;
    }
    else if(iFrameSrc.indexOf("signatures") != -1) {
        const prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
        const otb_sigListbox       = pageDoc.getElementById("otb_sigListbox");

        var description    = null;
		var signature      = null;
	    var listItem        = null;
		var signatureCount = 0;

        // If the signatures count preference is set
        if(prefService.prefHasUserValue("otb.singatures.count")) { signatureCount = prefService.getIntPref("otb.singatures.count"); }

        for(var i = 1; i <= signatureCount; i++)  { // Loop through the previous signatures
            description = "otb.opt.sig." + i + ".description";
            signature   = "otb.opt.sig." + i + ".signature";
            otb_optStr[description] = "";
            otb_optStr[signature]   = ""; }

		signatureCount = otb_sigListbox.getRowCount();
        for(i = 1; i <= signatureCount; i++)  {  // Loop through the possible signatures
            description = "otb.opt.sig." + i + ".description";
            signature   = "otb.opt.sig." + i + ".signature";
            listItem    = otb_sigListbox.getItemAtIndex(i - 1);
            otb_optStr[description] = listItem.label.trim();
            otb_optStr[signature]   = listItem.value.trim();
        }
        otb_optInt["otb.singatures.count"] = signatureCount;
    }
} // end otb_storeOptions()

function otb_saveOptions() { // Saves the user's options // prefService // string
	var option      = null;
    var optValue = null;

    otb_storeOptions();    // Make sure current page is stored

    for(option in otb_optBool) { prefService.setBoolPref(option, otb_optBool[option]); } // Loop through the boolean options

    for(option in otb_optInt) { // Loop through the integer options
        optValue = otb_optInt[option];
		if(optValue) { prefService.setIntPref(option, optValue);  } // If the option value is set
	    else if(prefService.prefHasUserValue(option)) { prefService.clearUserPref(option); }
    }

    for(option in otb_optStr) { // Loop through the string options
        optValue = otb_optStr[option];
        if(optValue || prefService.prefHasUserValue(option)) { // If the option value is set or the preference currently has a value
            string.data = optValue;
            prefService.setComplexValue(option, Components.interfaces.nsISupportsString, string);
        }
    }
	
	otbcommon.initprefs(otb_document);
} // end otb_saveOptions()

function otb_moveDown() { // Moves the selected item down
    const pageDoc   = document.getElementById("otb-options-iframe").contentDocument;
    const otb_sigListbox   = pageDoc.getElementById("otb_sigListbox");
    const selectedIndex  = otb_sigListbox.selectedIndex;
    const selectedItem   = otb_sigListbox.selectedItem;
    const signaturesCount = otb_sigListbox.getRowCount();

    if(selectedItem && selectedIndex != signaturesCount - 1) { // If an item is selected and it is not at the bottom
        otb_sigListbox.selectItem(otb_sigListbox.insertBefore(selectedItem, otb_sigListbox.getNextItem(selectedItem, 2)));
    }
}

function otbr_moveUp() { // Moves the selected item up
    const pageDoc  = document.getElementById("otb-options-iframe").contentDocument;
    const otb_sigListbox  = pageDoc.getElementById("otb_sigListbox");
    const selectedIndex = otb_sigListbox.selectedIndex;
    const selectedItem  = otb_sigListbox.selectedItem;

    if(selectedItem && selectedIndex != 0) {    // If an item is selected and it is not at the top
        otb_sigListbox.selectItem(otb_sigListbox.insertBefore(selectedItem, otb_sigListbox.getPreviousItem(selectedItem, 1)));
    }
}

function otbSelectItem() {
    const pageDoc  = document.getElementById("otb-options-iframe").contentDocument;
    const otb_sigListbox  = pageDoc.getElementById("otb_sigListbox");
	var selIdx = otb_sigListbox.selectedIndex;
    var rowCount = otb_sigListbox.getRowCount();
            
    pageDoc.getElementById("otb_sig_up").disabled = selIdx <= 0;
    pageDoc.getElementById("otb_sig_down").disabled = selIdx < 0 || selIdx >= rowCount - 1;
    pageDoc.getElementById("otb_sig_delete").disabled = selIdx < 0;
    pageDoc.getElementById("otb_sig_edit").disabled = selIdx < 0;
}

function otb_addSignature() { // Adds a signature
    const pageDoc = document.getElementById("otb-options-iframe").contentDocument;
    const otb_sigListbox = pageDoc.getElementById("otb_sigListbox");

    window.openDialog("chrome://orkutbar/content/options/dlg_signature.xul", "otb-signature-dialog", "centerscreen,chrome,modal", "add");

    if(otb_description) { // If the description is set
        var newItem = otb_sigListbox.appendItem(otb_description, otb_signature);
        otb_sigListbox.ensureElementIsVisible(newItem);
        otb_sigListbox.selectItem(newItem);
    }
}

function otb_deleteSignature() { // Deletes a signature
    const pageDoc  = document.getElementById("otb-options-iframe").contentDocument;
    const otb_sigListbox  = pageDoc.getElementById("otb_sigListbox");
    const selectedItem  = otb_sigListbox.selectedItem;
    const stringBundle  = document.getElementById("otbstrings");

    if(selectedItem && confirm(stringBundle.getString("otb.deleteConfirmation")))  { otb_sigListbox.removeChild(selectedItem); }
}

function otb_editSignature() { // Edits a signature
    const pageDoc = document.getElementById("otb-options-iframe").contentDocument;
    const otb_sigListbox = pageDoc.getElementById("otb_sigListbox");
    const selectedItem = otb_sigListbox.selectedItem;

    if(selectedItem) {  // If an item is selected
        window.openDialog("chrome://orkutbar/content/options/dlg_signature.xul", "otb_sig_dialog", "centerscreen,chrome,modal", "edit", selectedItem.label, selectedItem.value);

        if(otb_description) { // If the description is set
            selectedItem.label = otb_description;
            selectedItem.value = otb_signature;
            otb_sigListbox.ensureElementIsVisible(selectedItem);
        }
    }
}

//window.addEventListener('load', otb_init, true);